class SisRecordsController < ApplicationController

  before_filter :verify_sis_records_user

  def index
    unless params[:student_id].blank? 
      @sis_records = SisRecord.find(:all, :conditions => ['empl_id = ? OR computing_id = ?', params[:student_id], params[:student_id]])
    end
  end

  protected
  
  def verify_sis_records_user
    if current_user.nil?
      flash[:error] = "You must be logged in to view SIS Records."
      redirect_to root_path
    elsif !current_user.can_be_superuser? and !SisAdmin.find_by_user_id(current_user.id)
      flash[:error] = "You must be a SIS Administrator to view SIS Records."
      redirect_to root_path
    end
    
  end

end