# Be sure to restart your server when you modify this file

# Uncomment below to force Rails into production mode when
# you don't control web/app server and can't set it the proper way
# ENV['RAILS_ENV'] ||= 'production'

# Specifies gem version of Rails to use when vendor/rails is not present
# We need to make sure that rails 2.3.5 is used because that's what Blacklight uses
RAILS_GEM_VERSION = '2.3.15' unless defined? RAILS_GEM_VERSION

# Bootstrap the Rails environment, frameworks, and default configuration
require File.join(File.dirname(__FILE__), 'boot')

require File.join(File.dirname(__FILE__), '../vendor/plugins/engines/boot')


ENV['RECAPTCHA_PUBLIC_KEY']  = '6Lfeu8ISAAAAANeQxd80kaxTMlNCYa361jrfBdC0'
ENV['RECAPTCHA_PRIVATE_KEY'] = '6Lfeu8ISAAAAAJORYJRX9meXbZsKaceopuNb2UHT'


Rails::Initializer.run do |config|
  # Settings in config/environments/* take precedence over those specified here.
  # Application configuration should go into files in config/initializers
  # -- all .rb files in that directory are automatically loaded.
  # See Rails::Configuration for more options.

  # Skip frameworks you're not going to use (only works if using vendor/rails).
  # To use Rails without a database, you must remove the Active Record framework
  #config.frameworks -= [ :action_mailer ]
  
  # Only load the plugins named here, in the order given. By default, all plugins 
  # in vendor/plugins are loaded in alphabetical order.
  # :all can be used as a placeholder for all plugins not explicitly named
  config.plugin_paths += ["#{RAILS_ROOT}/vendor/plugins/blacklight/vendor/plugins"]  
  config.plugins = %W(engines blacklight acts_as_taggable_on_steroids resource_controller haml fluid-infusion hydra_repository stanford_salt white_list hydrangea_articles hydrangea_datasets recaptcha)
  
  # Add additional load paths for your own custom dirs
  # config.load_paths += %W( #{RAILS_ROOT}/extras )

  # Force all environments to use the same logger level
  # (by default production uses :info, the others :debug)
  config.log_level = :debug
  
  # Make Time.zone default to the specified zone, and make Active Record store time values
  # in the database in UTC, and return them converted to the specified local zone.
  # Run "rake -D time" for a list of tasks for finding time zone names. Comment line to use default local time.
  config.time_zone = 'Eastern Time (US & Canada)'
  
  # Your secret key for verifying cookie session data integrity.
  # If you change this key, all old sessions will become invalid!
  # Make sure the secret is at least 30 characters and all random, 
  # no regular words or you'll be exposed to dictionary attacks.
  config.action_controller.session = {
    :key => '_blacklight_session',
    :secret => '3e37cf3b7a9a3359f437aac207241fd25c2e2a107f85b2e6d32e0b5e3795e75fdb094b9d045d8c40e9ae2b38063c8926ef01b1e03946652eadf96c653d6effa9'
  }
  
  # Use the database for sessions instead of the cookie-based default,
  # which shouldn't be used to store highly confidential information
  # (create the session table with 'rake db:sessions:create')
  # config.action_controller.session_store = :active_record_store

  # Use SQL instead of Active Record's schema dumper when creating the test database.
  # This is necessary if your schema can't be completely dumped by the schema dumper,
  # like if you have constraints or database-specific column types
  # config.active_record.schema_format = :sql

  # Activate observers that should always be running
  # config.active_record.observers = :cacher, :garbage_collector
  
  # Make Active Record use UTC-base instead of local time
  # config.active_record.default_timezone = :utc
  config.middleware.use "UserAttributesLoader" if Rails.env == 'development'

  SSL_ENABLED=false

  FEEDBACK_NOTIFICATION_SUBJECT = 'Libra Feedback'

  SIS_INPUT_DIR='/home/sis-etd/from_sis'
  #SIS_OUTPUT_DIR='/home/sis-etd/to_sis'
  SIS_OUTPUT_DIR='/usr/local/projects/uva/sis-etd/to_sis'

  #Directory to put the file of UVA network IP that can used for access control of embargoed etds from ASG
  UVA_IP_RANGES_LIST_DIR ='/home/uva-network'

  # array of academic_program as provided by SIS and present in sis_records table.  If the academic_program is one where students
  # in that program are allowed to use Libra to submit an ETD, add that value to this array.
  ETD_SCHOOLS = ["ENG","ASG", "NRG","CUG", "ARG"]

  #Array of academic_program that will use ASG template
  ASG_TEMPLATE = ["ASG","NRG","CUG","ARG"]

  # URL of a survey launched after ETD submission
  # Comment out on Jan.2016, this is not currently applicable
  # ETD_SURVEY_URL = 'https://www.surveymonkey.com/s/8CQRYGP'

  #To avoid client-side control of "Submit" button, set default of this constant as false
  CLIENT_SIDE_READINESS_CHECK = false

  # This constant is set to override default "rows"" paramter in Solr query
  UVA_SOLR_ROWS_NUM = '100'

  APP_VERSION = `git describe --abbrev=0` unless defined? APP_VERSION

  LIBRA2 = 'https://libra2.lib.virginia.edu/'



end
