@edit @articles
Feature: Edit a document
  In order to [goal]
  [stakeholder]
  wants [behaviour]
  
  @overwritten
  Scenario: Visit Document Edit Page
    Given I am logged in as "archivist1" 
    And I am on the edit document page for hydrangea:fixture_mods_article1 
    Then I should see an inline edit containing "ARTICLE TITLE"
  
  @local
  Scenario: Visit Document Edit Page
    Given I am logged in as "archivist1" 
    And I am on the edit document page for libra-oa:1
    Then the "mods_title_info_main_title" inline edit should contain "The Smallest Victims of the "

  # the mockups for Libra did not have browse/edit buttons
  @overwritten
  Scenario: Viewing browse/edit buttons
    Given I am logged in as "archivist1" 
    And I am on the edit document page for hydrangea:fixture_mods_article1
    Then I should see a "span" tag with a "class" attribute of "edit-browse"

  # the mockups for Libra did not have a delete confirmation
  @overwritten
  Scenario: Delete Confirmation on Edit Page
    Given I am logged in as "archivist1" 
    And I am on the edit document page for hydrangea:fixture_mods_article1 
    Then I should see a "div" tag with an "id" attribute of "delete_dialog_container"
    And I should see "Permanently delete"
    
  @local
  Scenario: Show delete option for items that have not been released
    Given I am logged in as "archivist1"
    And I am on the edit document page for libra-oa:9
    Then I should see "Delete this article"
    
  @local
  Scenario: Do not show delete option for items that have been released
    Given I am logged in as "archivist1"
    And I am on the edit document page for libra-oa:7
    Then I should see "This object has been released for circulation and may be modified but not deleted. For assistance with deleting this object, please contact the administrators. "

  @local
  Scenario: Show the delete option for a superuser, even if the item has been released
    Given I am a superuser
    And I am on the edit document page for libra-oa:7
    Then I should see "Delete this article"
    
