@catalog @articles
Feature: Article Search Result
  As a user
  In order to find articles
  I want to see appropriate information about articles in a search result

  @overwritten
  Scenario: Viewing search results
    Given I am on the home page
    And I fill in "q" with "1234-5678"
    When I press "search"
    Then I should see a link to "the show document page of hydrangea:fixture_mods_article3"
    And I should see "Test Article"
    And I should see "1998-08-01 9:22p"
	  And I should see "Article"
	  And I should see "The Journal of Mock Object"

  @local
  Scenario: Viewing search results
    Given I am on the home page
    And I fill in "q" with "zotero article"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:10"
    And I should see "Article"
    And I should see "Blahbitty, Winter 2009"

  @local
  Scenario: Embargoed items should show up in search results for unauthenticated user
    Given I am on the home page
    And I fill in "q" with "Embargoed"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:14"
    
  @local
  Scenario: Embargoed items should show up in search results for authenticated user who is not the owner
    Given I am logged in as "someuser"
    And I am on the home page
    And I fill in "q" with "Embargoed"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:14"
    
  @local
  Scenario: Embargoed items should show up in search results for authenticated user who is the owner
    Given I am logged in as "mcp6n"
    And I am on the home page
    And I fill in "q" with "Embargoed"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:14"
    
  @local
  Scenario: Embargoed items should show up in search results for a superuser
    Given I am superuser "ruler"
    And I am on the home page
    And I fill in "q" with "Embargoed"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:14"
    
  @local
  Scenario: Unauthenticated user should not be able to discover an item that has not been released
    Given I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should not see a link to "the show document page of libra-oa:16"
    
  @local
  Scenario: Authenticated user who is not the owner should not be able to discover an item that has not been released
    Given I am logged in as "blahuser"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should not see a link to "the show document page of libra-oa:16"
    
  @local
  Scenario: Authenticated user who is the owner should be able to discover an item that has not been released
    Given I am logged in as "mcp6n"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:16"

  @local
  Scenario: Superuser should be able to discover an item that has not been released
    Given I am superuser "big_man_on_campus"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:16"
    
  @local
  Scenario: Unauthenticated user should be able to discover a UVa-only document
    Given I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:18"
  
  @local
  Scenario: Authenticated user who is not the owner should be able to discover a UVa-only document
    Given I am logged in as "rufus"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:18"
    
  @local
  Scenario: Authenticated user who is the owner should be able to discover a UVa-only document
    Given I am logged in as "mcp6n"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:18"
    
   @local
  Scenario: Superuser should be able to discover a UVa-only document
    Given I am superuser "bigman"
    And I am on the home page
    And I fill in "q" with "released"
    And I press "search"
    Then I should see a link to "the show document page of libra-oa:18"

