@show @articles
Feature: Show a document
  In order to [goal]
  [stakeholder]
  wants [behaviour]

  @overwritten
  Scenario: Public visit Publicly Viewable Document
    Given I am on the show document page for hydrangea:fixture_mods_article1
    Then I should see "ARTICLE TITLE"
    And I should see "GIVEN NAMES"
    And I should see "FAMILY NAME"
    And I should see "FACULTY, UNIVERSITY"
    And I should see "TOPIC 1"
    And I should see "TOPIC 2"
    And I should see "CONTROLLED TERM"
    And I should not see a link to "the edit document page for hydrangea:fixture_mods_article1"
   
  @local
  Scenario: Public visit Publicly Viewable Document
    Given I am on the show document page for libra-oa:1
    Then I should see "The Smallest Victims of the"
    And I should see "Mary"
    And I should see "Gibson"
    And I should see "University of Virginia"
    And I should see "white plague"
    And I should see "pediatric nursing"
    And I should see "Libra Public Deposit License"
    And I should not see a link to "the edit document page for libra-oa:1"
  
  @overwritten
  Scenario: Public visit Document Show Page for a private document  
    Given I am on the show document page for hydrangea:fixture_archivist_only_mods_article
    Then I should be on the search page
    And I should see "You do not have sufficient access privileges to read this document, which has been marked private" within ".notice"
  
  @overwritten
  Scenario: Superuser visits Document Show Page for a private document
    Given I am a superuser
    And I am on the show document page for hydrangea:fixture_archivist_only_mods_article
    Then I should see "Article for Archivist Eyes Only"
   
  @overwritten
  Scenario: Superuser visits Document Show Page for a private document
    Given I am a superuser
    And I am on the show document page for libra-oa:7
    Then I should see "Khadzhi-Murat's Silence"
  
  @overwritten
  Scenario: Archivist visits Show Page for Restricted Document
    Given I am logged in as "archivist1" 
    And I am on the show document page for hydrangea:fixture_archivist_only_mods_article
    Then I should see "Article for Archivist Eyes Only"
    And I should see "Sally"
    And I should see "Whocontributes"
    And I should see "University of Contributions"
    And I should see "contributing"
    And I should see "exclusiveness"
    And I should not see a link to "the edit document page for hydrangea:fixture_public_mods_article"
  
  @local
  Scenario: Archivist visits Show Page for Restricted Document
    Given I am logged in as "archivist1" 
    And I am on the show document page for libra-oa:7
    Then I should see "Khadzhi-Murat's Silence"
    And I should see "Herman, David"
    And I should see "University of Virginia"

  @local
  Scenario: Zotero span should appear
    Given I am on the show document page for libra-oa:10
    Then I should see a zotero tag for "ctx_ver=Z39.88-2004&amp;rft_val_fmt=info%3Aofi%2Ffmt%3Akev%3Amtx%3Ajournal&amp;rfr_id=info%3Asid%2Fblacklight.rubyforge.org%3Agenerator&amp;rft.genre=article&amp;rft.title=Blahbitty&amp;rft.atitle=Zotero+Test+Article&amp;rft.au=Mary+Pickral&amp;rft.date=&amp;rft.issn=12345&amp;rft.issue=45&amp;rft.volume=35&amp;rft.spage=55&amp;rft.epage=65"
  
  @local
  Scenario: Unauthenticated user should see an embargoed document but not its file
    Given I am on the show document page for libra-oa:14
    Then I should see "Embargoed until 9/14/2020"
    And I should not see "gallia.pdf"
    And I should see "This item is under embargo until 2020-09-14."

  @local
  Scenario: Authenticated user who is not the owner of an embargoed document should be able to see the document but not its file
    Given I am logged in as "fakeuser"
    And I am on the show document page for libra-oa:14
    Then I should see "Embargoed until 9/14/2020"
    And I should not see "gallia.pdf"
    And I should see "This item is under embargo until 2020-09-14."
  
  @local
  Scenario: Document owner should see an embargoed document and its file
    Given I am logged in as "mcp6n"
    And I am on the show document page for libra-oa:14
    Then I should see "Embargoed until 9/14/2020"
    And I should see "gallia.pdf"
    
  @local
  Scenario: Superuser should see an embargoed document and its file
    Given I am superuser "uberdude"
    And I am on the show document page for libra-oa:14
    Then I should see "Embargoed until 9/14/2020"
    And I should see "gallia.pdf"
    
  @local
  Scenario: Unauthenticated user should not see an unreleased document
    Given I am on the show document page for libra-oa:16
    Then I should see "You do not have sufficient access privileges to read this document, which has been marked private."

  @local
  Scenario: Authenticated user who is not the owner should not see an unreleased document
    Given I am logged in as "foouser"
    And I am on the show document page for libra-oa:16
    Then I should see "You do not have sufficient access privileges to read this document, which has been marked private."
    
  @local
  Scenario: Owner should be able to see an unreleased document and its file
    Given I am logged in as "mcp6n"
    And I am on the show document page for libra-oa:16
    Then I should see "Not Released"
    And I should see "gallia.pdf"

  @local
  Scenario: Superuser should be able to see an unreleased document and its file
    Given I am superuser "megauser"
    And I am on the show document page for libra-oa:16
    Then I should see "Not Released"
    And I should see "gallia.pdf"
  
  @local
  Scenario: Unauthenticated user should see a UVa-only document but not the file
    Given I am on the show document page for libra-oa:18
    Then I should see "Released for U.Va. only"
    And I should not see "gallia.pdf"
    And I should see "License restrictions require UVa login for this item. "
  
  @local
  Scenario: Authenticated user who is not the owner should see a UVa-only document and its file
    Given I am logged in as "jane"
    And I am on the show document page for libra-oa:18
    Then I should see "Released for U.Va. only"
    And I should see "gallia.pdf"
    
  @local
  Scenario: Owner should see a UVa-only document and its file
    Given I am logged in as "mcp6n"
    And I am on the show document page for libra-oa:18
    Then I should see "Released for U.Va. only"
    And I should see "gallia.pdf"
    
  @local
  Scenario: Superuser should see a UVa-only document and its file
    Given I am superuser "uberdudette"
    And I am on the show document page for libra-oa:18
    Then I should see "Released for U.Va. only"
    And I should see "gallia.pdf"
