@file_assets
Feature: Files for a document
  In order
  As an editor or non-editor
  I want 
  
  @local
  Scenario: Unauthenticated user should not be able to view embargoed file
  Given I am on the file asset "libra-oa:15"
    Then I should see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local    
  Scenario: Authenticated user who is not the owner should not be able to view embargoed file
  Given I am logged in as "nosyperson"
   And I am on the file asset "libra-oa:15"
   Then I should see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local   
  Scenario: Owner should be able to view embargoed file
  Given I am logged in as "mcp6n"
    And I am on the file asset "libra-oa:15"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local    
  Scenario: Owner should be able to view embargoed file
  Given I am superuser "honcho"
    And I am on the file asset "libra-oa:15"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local    
  Scenario: Unauthenticated user should not be able to view the file of an unreleased document
  Given I am on the file asset "libra-oa:17"
    Then I should see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local      
  Scenario: Authenticated user who is not the owner should not be able to see the file of an unreleased document
  Given I am logged in as "bizzybody"
    And I am on the file asset "libra-oa:17"
    Then I should see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local    
  Scenario: Owner should be able to see the file of an unreleased document
  Given I am logged in as "mcp6n"
    And I am on the file asset "libra-oa:17"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local    
  Scenario: Superuser should be able to see the file of an unreleased document
  Given I am superuser "hoss"
    And I am on the file asset "libra-oa:17"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."
    
  @local
  Scenario: Unauthenticated user should not be able to view the file of a UVa-only document
  Given I am on the file asset "libra-oa:19"
    Then I should see "You do not have sufficient access privileges to download this document, which has been marked private."
    
  @local
  Scenario: Authenticated user should be able to view the file of a UVa-only document
  Given I am logged in as "jane"
    And I am on the file asset "libra-oa:19"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."

  @local
  Scenario: Owner should be able to view the file of a UVa-only document
  Given I am logged in as "mcp6n"
    And I am on the file asset "libra-oa:19"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."
    
  @local
  Scenario: Superuser should be able to view the file of a UVa-only document
  Given I am superuser "tarzan"
    And I am on the file asset "libra-oa:19"
    Then I should not see "You do not have sufficient access privileges to download this document, which has been marked private."