Then /^I should see the user menu option "([^"]*)"$/ do |arg1|
  response.should have_tag("li.util_menu ul li", :text => arg1)
end

Then /^I should not see the user menu option "([^"]*)"$/ do |arg1|
  response.should_not have_tag("li.util_menu ul li", :text => arg1)
end

Given (/^I am logged in as "([^\"]*)"$/) do |login|
  email = "#{login}@#{login}.com"
  user = User.find_or_create_by_login(:login => login, :email => email, :password => "password", :password_confirmation => "password")
  begin
    visit user_sessions_path(:user_session => {:login => login, :password => "password"}), :post
  rescue Webrat::InfiniteRedirectError => e
    # do nothing
  end
  User.find(user.id).should_not be_nil
end

Given /^I am a superuser$/ do
  login = "BigWig"
  email = "bigwig@bigwig.com"
  user = User.find_or_create_by_login(:login => login, :email => email, :password => "password", :password_confirmation => "password")
  superuser = Superuser.find_or_create_by_user_id(:user_id => user.id)
  visit user_sessions_path(:user_session => {:login => login, :password => "password"}), :post
  visit superuser_path
end

Given /^I am a sis admin$/ do
  login = "SisAdmin"
  email = "blah@blah.com"
  user = User.find_or_create_by_login(:login => login, :email => email, :password => "password", :password_confirmation => "password")
  sis_admin = SisAdmin.find_or_create_by_user_id(:user_id => user.id)
  visit user_sessions_path(:user_session => {:login => login, :password => "password"}), :post
end

Given /^I am superuser "([^\"]*)"$/ do |login|
  email = "#{login}@bigwig.com"
  user = User.find_or_create_by_login(:login => login, :email => email, :password => "password", :password_confirmation => "password")
  superuser = Superuser.find_or_create_by_user_id(:user_id => user.id)
  visit user_sessions_path(:user_session => {:login => login, :password => "password"}), :post
  visit superuser_path
end

Given /^I am logged in as "([^\"]*)" who can upload a doctoral dissertation$/ do |login|
  job = Uva::SisTransfer.new('120211')
  job.stubs(:input_file).returns('spec/fixtures/sis_transfer_example.txt')
  job.set_input_data
  job.write_input_data
  email = "#{login}@#{login}.com"
  user = User.find_or_create_by_login(:login => login, :email => email, :password => "password", :password_confirmation => "password")
  begin
    visit user_sessions_path(:user_session => {:login => login, :password => "password"}), :post
  rescue Webrat::InfiniteRedirectError => e
    # do nothing
  end
  User.find(user.id).should_not be_nil
end
