module Hydra::AssetsControllerHelper
  require_dependency 'vendor/plugins/hydra_repository/lib/hydra/assets_controller_helper.rb'
  require 'facets/dictionary'
  
  # 
  # parses your params hash, massaging them into an appropriate set of params and opts to pass into ActiveFedora::Base.update_indexed_attributes
  #
  def prep_updater_method_args(params)
    args = {:params=>{}, :opts=>{}}
    
    params["asset"].each_pair do |datastream_name,fields|
      
      args[:opts][:datastreams] = datastream_name
      
      # TEMPORARY HACK: special case for supporting textile 
      if params["field_id"]=="abstract_0" 
        params[:field_selectors] = {"descMetadata" => {"abstract" => [:abstract]}}
      end
      
      if params.fetch("field_selectors",false) && params["field_selectors"].fetch(datastream_name, false)
        # If there is an entry in field_selectors for the datastream (implying a nokogiri datastream), retrieve the field_selector for this field.
        # if no field selector, exists, use the field name
        fields.each_pair do |field_name,field_values|
          parent_select = OM.destringify( params["field_selectors"][datastream_name].fetch(field_name, field_name) )
          if field_values.has_key?("multi")
            # figure out how many we have already
            desc_ds = @document.datastreams_in_memory["descMetadata"]
            count = desc_ds.find_by_terms(*parent_select).count
            # split up the comma-separated input
            vals = field_values["multi"].split(", ")
            val_hash = {}
            # add new ones at the end of the list
            vals.each_with_index do |val, index|
              val_hash["#{(count + index) * 100}"] = val.strip
            end
            args[:params][parent_select] = val_hash
          else
            # trim spaces on values
            field_values.each_value{ |val| val.strip! }
            args[:params][parent_select] = field_values       
          end
        end        
      else
        args[:params] = unescape_keys(params[:asset][datastream_name])
      end
    end
    
    return args
     
  end
end