module Hydra::FileAssetsHelper
  require_dependency 'vendor/plugins/hydra_repository/lib/hydra/file_assets_helper.rb'

  # Creates a File Asset, adding the posted blob to the File Asset's datastreams and saves the File Asset
  #
  # @return [FileAsset] the File Asset  
  def create_and_save_file_asset_from_params
    if params.has_key?(:Filedata)
      @file_asset = create_asset_from_params
      add_posted_blob_to_asset
      @file_asset.save
      
      # record if it's a readme, dataset, or other
      if params.has_key?(:file_type_select)
        @file_asset.datastreams_in_memory["descMetadata"].description_values =  params[:file_type_select]
      end

      return @file_asset
    else
      return false
    end
  end
  
  
end