# require File.expand_path(File.dirname(__FILE__) + '/hydra_jetty.rb')
require "solrizer-fedora"

namespace :libra_oa do
  
  namespace :default_fixtures do

    LIBRA_OA_FIXTURE_FILES = [
        "libra-oa_1.foxml.xml",
        "libra-oa_2.foxml.xml",
        "libra-oa_3.foxml.xml",
        "libra-oa_4.foxml.xml",
        "libra-oa_5.foxml.xml",
        "libra-oa_6.foxml.xml",
        "libra-oa_7.foxml.xml",
        "libra-oa_8.foxml.xml",
        "libra-oa_9.foxml.xml",
        "libra-oa_10.foxml.xml",
        "libra-oa_11.foxml.xml",
        "libra-oa_12.foxml.xml",
        "libra-oa_13.foxml.xml",
        "libra-oa_14.foxml.xml",
        "libra-oa_15.foxml.xml",
        "libra-oa_16.foxml.xml",
        "libra-oa_17.foxml.xml",
        "libra-oa_18.foxml.xml",
        "libra-oa_19.foxml.xml",
        "libra-oa_20.foxml.xml",
        "libra-oa_21.foxml.xml",
        "libra-oa_22.foxml.xml",
        "libra-oa_23.foxml.xml",
        "libra-oa_24.foxml.xml",
        "libra-oa_25.foxml.xml",
        "libra-oa_26.foxml.xml"                
    ]
    LIBRA_OA_FIXTURES = [
        "libra-oa:1",
        "libra-oa:2",
        "libra-oa:3",
        "libra-oa:4",
        "libra-oa:5",
        "libra-oa:6",
        "libra-oa:7",
        "libra-oa:8",
        "libra-oa:9",
        "libra-oa:10",
        "libra-oa:11",
        "libra-oa:12",
        "libra-oa:13",
        "libra-oa:14",
        "libra-oa:15",
        "libra-oa:16",
        "libra-oa:17",
        "libra-oa:18",
        "libra-oa:19",
        "libra-oa:20",
        "libra-oa:21",
        "libra-oa:22",
        "libra-oa:23",
        "libra-oa:24",
        "libra-oa:25",
        "libra-oa:26"
    ]

    desc "Load default libra-oa fixtures"
    task :load do
      LIBRA_OA_FIXTURE_FILES.each_with_index do |fixture,index|
        ENV["fixture"] = "#{Rails.root}/spec/fixtures/#{fixture}"
        Rake::Task["hydra:import_fixture"].invoke if index == 0
        Rake::Task["hydra:import_fixture"].execute if index > 0
      end
      LIBRA_OA_FIXTURES.each_with_index do |fixture,index|
        ENV["PID"] = fixture
        Rake::Task["solrizer:fedora:solrize"].invoke if index == 0
        Rake::Task["solrizer:fedora:solrize"].execute if index > 0
      end
      LIBRA_OA_FIXTURES.each_with_index do |fixture,index|
        ENV["PID"] = fixture
        Rake::Task["solrizer:fedora:solrize"].execute
      end
    end

    desc "Remove default libra-oa fixtures"
    task :delete do
      LIBRA_OA_FIXTURES.each_with_index do |fixture,index|
        ENV["pid"] = fixture
        puts "deleting #{fixture}"
        puts "#{ENV["pid"]}"
        Rake::Task["hydra:delete"].invoke if index == 0
        Rake::Task["hydra:delete"].execute if index > 0
      end
    end

    desc "Refresh default libra-oa fixtures"
    task :refresh do
      Rake::Task["libra_oa:default_fixtures:delete"].invoke
      Rake::Task["libra_oa:default_fixtures:load"].invoke
    end
  end

end
