module Uva::UserAttributes
  def can_upload_masters_thesis?
    can_upload_etd_type?(HydrangeaMastersThesis.sis_type)
  end

  def can_upload_dissertation?
    can_upload_etd_type?(HydrangeaDoctoralDissertation.sis_type)
  end
  
  def can_upload_fourth_year_thesis?
    can_upload_etd_type?(HydrangeaFourthYearThesis.sis_type)
  end

  def can_upload_etd_type?(etd_type)
    return true if can_be_superuser?
    etd_type = translate_etd_type(etd_type)
    return true if SisRecord.find(:all, :conditions => ["computing_id = ? AND milestone = ? AND libra_approved IS NULL AND academic_program IN (?)", self.login, etd_type, ETD_SCHOOLS]).count > 0
    return false
  end
  
  def translate_etd_type(etd_type)
    mappings = HydrangeaMastersThesis.sis_mapping.merge!(HydrangeaDoctoralDissertation.sis_mapping).merge!(HydrangeaFourthYearThesis.sis_mapping)
    if mappings.has_key?(etd_type)
      etd_type = mappings[etd_type] 
    elsif mappings.has_value?(etd_type)
      # we're good
    else
      etd_type = "invalid"
    end
    etd_type
  end
  
  def can_upload_etd?
    can_upload_masters_thesis? or can_upload_dissertation? or can_upload_fourth_year_thesis?
  end
  
end