(function($) {
  
  $.fn.hydraProgressBox = {    
    /*
    *  hydraProgressBox.checkUncheckProgress
    *  Change the checked/unchecked status of an item in the Progress Box
    *  @param 
    *
    * ie. 
    * hydraProgressBox.checkUncheckProgress($(true, 'pbCitationDetails');
    */
    checkUncheckProgress: function(elementId, bool) {  
        el = $("#"+elementId);
        if (bool) {
          el.addClass("progressItemChecked") 
          el.css("background-image",'url(/images/chkbox_checked.png)')
          // el.show();
        } else {
          el.removeClass("progressItemChecked")    
          el.css("background-image",'url(/images/chkbox_empty.png)')      
        };
        $.fn.hydraProgressBox.testReleaseReadiness();
    },
    
    showProcessingInProgress: function(elementId) {
      el = $("#"+elementId);
      el.css("background-image", 'url(/images/processing.gif)');
      // el.show();
    },
    
    testStepOneReadiness: function() {
      var contentType = $("#content_type").val();
      var stepOneIsReady= false;
      // add customizations here if adding more content types... might want case statement instead
      if ( contentType == "hydrangea_article" || contentType == "hydrangea_book" || contentType == "hydrangea_article_preprint" || contentType == "hydrangea_conference_paper" || contentType=="hydrangea_book_chapter" || contentType=="hydrangea_book_part" || contentType=="hydrangea_fourth_year_thesis" || contentType=="hydrangea_masters_thesis" || contentType=="hydrangea_doctoral_dissertation" || contentType=="hydrangea_dataset") {
        var titleProvided = ($("#mods_title_info_main_title").attr("value").length > 0);
        var authorLastProvided = ($("#person_0_last_name").attr("value").length > 0);
        var authorFirstProvided =  ($("#person_0_first_name").attr("value").length > 0 );
        var licenseAgreedTo = ($("#pbAvailability .fedora-radio-button:checked").val() == "public" || $("#pbAvailability .fedora-radio-button:checked").val() == "uva" || $("#pbAvailability .fedora-radio-button:checked").val() == "uetd" || $("#pbAvailability .fedora-radio-button:checked").val() == "public_dataset");	
		if ((contentType == "hydrangea_fourth_year_thesis") || (contentType == "hydrangea_masters_thesis") || (contentType == "hydrangea_doctoral_dissertation")) {
			var fileUploaded = ($('#file_assets .file_asset .thesis').length == 1);
         	}    
		else {
			var fileUploaded = ( $('.file_asset').length > 0 || $("#uploads .upload_success").length > 0); 
			}
	
        if (fileUploaded && titleProvided && authorLastProvided && authorFirstProvided && licenseAgreedTo) {
          stepOneIsReady=true;
        }
      }
      return stepOneIsReady;
    },

    testStepTwoReadiness: function() {
      if ( $("#content_type").val() == "hydrangea_article") {
        return ( ($("#journal_0_title_info_main_title").val().length > 0) && ($("#publication_year_fieldset select").val() != "Select Year") );
      } else if ( $("#content_type").val() == "hydrangea_article_preprint") {
        return ( ($("#journal_0_title_info_main_title").val().length > 0) && ($("#publication_year_fieldset select").val() != "Select Year") );	
      } else if ( $("#content_type").val() == "hydrangea_book") {
        return ( ($("#origin_info_publisher").val().length > 0) && ($("#publication_year_fieldset select").val() != "Select Year") );
      } else if ( $("#content_type").val() == "hydrangea_conference_paper") {
				return ( ($("#conference_paper_0_name_conference_name").val().length > 0) && ($("#conference_year_fieldset select").val() != "Select Year") );
			} else if ( $("#content_type").val() == "hydrangea_book_chapter") {
				var title = ($("#book_0_title_info_main_title").val().length > 0);
				var publisher = ( ($("#book_0_origin_info_publisher").val().length > 0) && ($("#publication_year_fieldset select").val() != "Select Year") );
				if (title && publisher) {
					return true;
				} else {
					return false;
				}
	  } else if ( $("#content_type").val() == "hydrangea_fourth_year_thesis" || $("#content_type").val() == "hydrangea_masters_thesis" || $("#content_type").val() == "hydrangea_doctoral_dissertation"){
		var degree = ($("#extension_degree_level").val().length > 0);
		var approved = ($("#origin_info_date_issued").val().length > 0);
		var advisorFirstProvided = ($(".advisor .name_first input.editable-edit").val().length > 0);
        var advisorLastProvided =  ($(".advisor .name_last input.editable-edit").val().length > 0 );
		var abstract = ($("#abstract").val().length > 0);
		if (degree && approved && advisorFirstProvided && advisorLastProvided && abstract) {
			return true;
		} else {
			return false;
		}
		
    } else if ( $("#content_type").val() == "hydrangea_book_part") {
		var title = ($("#book_0_title_info_main_title").val().length > 0);
		var publisher = ($("#book_0_origin_info_publisher").val().length > 0);
		var editor = ($("#book_editor_last_name_0").val().length > 0);
		if (title && publisher && editor) {
			return true;
		} else {
			return false;
		}
    } else if ( $("#content_type").val() == "hydrangea_dataset") {
      var has_readme = ($('.file_asset .readme').length > 0 );
      var has_data_file = ($('.file_asset .dataset').length > 0 );
      var data_created = ($("#origin_info_date_created").val().length > 0);
      var abstract = ($("#abstract").val().length > 0);
      var met_requirements = $('#dataset_agreements input[type=checkbox]:not(:checked)').length == 0;
      if (met_requirements && has_readme && has_data_file && data_created && abstract) {
        return true;
      } else {
        return false;
      }
	} else {
        return true;
      }
    },

    testStepThreeReadiness: function() {
      var contentType = $("#content_type").val();
      var stepThreeIsReady = true;

      // For ETDs, verify that an embargo selection has been made.  (In cases
      // where a default selection has not been provided, this insures that
      // the submitter has made a manual selection.)
      if ((contentType == "hydrangea_fourth_year_thesis") ||
          (contentType == "hydrangea_masters_thesis") ||
          (contentType == "hydrangea_doctoral_dissertation")) {
        if ($("#pbEmbargo .fedora-radio-button:checked").val() == undefined ) {
			stepThreeIsReady = false;
		} else {
			stepThreeIsReady = true;
		}
      }     
      return stepThreeIsReady;
    },

    testReleaseReadiness: function() {
      var stepOneComplete = $.fn.hydraProgressBox.testStepOneReadiness();
      var stepTwoComplete = $.fn.hydraProgressBox.testStepTwoReadiness();
	  var stepThreeComplete = $.fn.hydraProgressBox.testStepThreeReadiness();
      var releaseIsReady    = (stepOneComplete && stepTwoComplete && stepThreeComplete);
      if (releaseIsReady) {
					$("#submitForRelease").enable();
      } else {
          $('#submitForRelease').attr("disabled", "disabled");			
      }
      return releaseIsReady;
    }
  };
})( jQuery );
