require File.expand_path(File.dirname(__FILE__) + '/../spec_helper')


# See cucumber tests (ie. /features/edit_document.feature) for more tests, including ones that test the edit method & view
# You can run the cucumber tests with 
#
# cucumber --tags @edit
# or
# rake cucumber

describe CatalogController do
  
  before do
    #request.env['WEBAUTH_USER']='bob'
  end
  
  describe "edit" do
    it "should enforce edit permissions, redirecting to show action and resetting session context if user does not have edit permissions" do
      mock_user = mock("User")
      mock_user.stubs(:login).returns("patron1")
      mock_user.stubs(:is_being_superuser?).returns(false)
      mock_user.stubs(:can_be_superuser?).returns(false)
      controller.stubs(:current_user).returns(mock_user)
      
      get :edit, :id=>"hydrangea:fixture_mods_article1"
      response.should redirect_to(:action => 'show')
      flash[:notice].should == "You do not have sufficient privileges to edit this document. You have been redirected to the read-only view."
    end
    it "should render normally if user has edit permissions" do
      mock_user = stub("User", :login=>"archivist1")
      controller.stubs(:current_user).returns(mock_user)
      
      get :edit, :id=>"hydrangea:fixture_mods_article1"
      response.should_not redirect_to(:action => 'show')
    end
  end
  
end
