require File.expand_path( File.join( File.dirname(__FILE__),'..','spec_helper') )

describe IssnLookup do
  
  class FakeIssnLookup < IssnLookup
    def initialize(fixture_file)
      @doc =  Nokogiri::XML(fixture(fixture_file).read)
    end
  end
  
  before(:each) do
    @doc_success = FakeIssnLookup.new("sherpa_1.xml")
    @doc_bad = FakeIssnLookup.new("sherpa_2.xml")
  end
  
  describe "has_data?" do
    it "should know when there are hits returned" do
      @doc_success.has_data?.should be_true
    end
  
    it "should know when there are no hits returned" do
      @doc_bad = FakeIssnLookup.new("sherpa_2.xml")
      @doc_bad.has_data?.should be_false
    end
  end
  
  describe "journal_title" do
    it "should return the title if there are hits" do
      @doc_success.journal_title.should == "Geriatrics and Gerontology International"
    end
    it "should return an empty string if there are no hits" do
      @doc_bad.journal_title.should == ""
    end
  end
  
  describe "publisher" do
    it "should return the publisher if there are hits" do
      @doc_success.publisher.should == "Wiley-Blackwell"
    end
    it "should return an empty string if there are no hits" do
      @doc_bad.publisher.should == ""
    end

  end


end