# Need way to find way to stub current_user and RoleMapper in order to run these tests
require File.expand_path( File.join( File.dirname(__FILE__), '..','..','spec_helper') )


describe Uva::ModsIndexMethods do
  describe "extract_uva_departments" do
    it "should return an array of Solr::Field objects for :uva_department_facet" do
      departments = HydrangeaArticle.find("libra-oa:10").datastreams["descMetadata"].extract_uva_departments
      departments.should be_kind_of Array
      departments.length.should == 2
      departments.first.should be_kind_of Solr::Field
      departments.first.value.should == "University of Virginia Library"
      departments.second.should be_kind_of Solr::Field
      departments.second.value.should == "University of Virginia Library"
    end
    it "should get the uva department display facet" do
      DepartmentFacetMapping.create(:department_facet => 'Computer Science', :department_display_facet => 'Department of Computer Science')
      departments = HydrangeaArticle.find("libra-oa:16").datastreams["descMetadata"].extract_uva_departments
      departments.first.value.should == "Computer Science"
      departments.second.value.should == "Department of Computer Science"
    end
  end
  
  describe "uva_department_display_facet" do
    it "should find a mapping based on the selected department" do
      DepartmentFacetMapping.create(:department_facet => 'Computer Science', :department_display_facet => 'Department of Computer Science')
      HydrangeaArticle.find("libra-oa:12").datastreams["descMetadata"].uva_department_display_facet('Computer Science').should == "Department of Computer Science"
    end
  end
  
end