# Need way to find way to stub current_user and RoleMapper in order to run these tests
require File.expand_path( File.join( File.dirname(__FILE__), '..','..','spec_helper') )

describe Uva::UserAttributes do
  it "should let a superuser do uplaods" do
   user = mock("User")
   user.extend(Uva::UserAttributes)
   user.stubs(:can_be_superuser?).returns(true)
   user.can_upload_etd_type?(HydrangeaDoctoralDissertation.sis_type).should be_true
  end
  it "should allow an upload if the user is in the sis table" do
    # set up SIS table entries
    job = Uva::SisTransfer.new('120211')
    job.stubs('input_file').returns('spec/fixtures/sis_transfer_example.txt')
    job.set_input_data
    job.write_input_data
    # fake up user that matches
    user = mock("User")
    user.extend(Uva::UserAttributes)
    user.stubs(:can_be_superuser?).returns(false)
    user.stubs(:login).returns("testuser")
    user.can_upload_dissertation?.should be_true
  end
  it "should translate etd type" do
     user = mock("User")
     user.extend(Uva::UserAttributes)
     user.translate_etd_type(HydrangeaDoctoralDissertation.sis_type).should == HydrangeaDoctoralDissertation.sis_type
     user.translate_etd_type(HydrangeaDoctoralDissertation.libra_type).should == HydrangeaDoctoralDissertation.sis_type
     user.translate_etd_type("stuff").should == "invalid"
  end
end